// -*- mode: c++; -*-

#if !defined(WIN32)
#include <dlfcn.h>
#else
#include <windows.h>
#endif

#include "factory.h"

namespace regime {

  void* library_loader::load(const std::string& library) {
#if !defined(WIN32)
    return dlopen(library.c_str(), RTLD_LAZY);
#else
    return ::LoadLibrary(library.c_str());
#endif
  }

  void library_loader::unload(void* handle) {
#if !defined(WIN32)
    dlclose(handle);
#else
        ::FreeLibrary((HINSTANCE)handle);
#endif
  }
}
