#pragma warning(disable:4786 4503)
#include <iostream>
#include "factory.h"
#include "factory.cxx"
#include "product.h"
using std::cout;
using std::endl;
using std::copy;
using std::map;
using std::ostream_iterator;
using std::ostream;
using std::set;
using std::string;


typedef regime::factory<int,MyBase> IntFactory;
typedef regime::factory<string,MyBase> StringFactory;


class MyProduct1 : public MyBase {
  string m_parameter;
public:
  MyProduct1() : MyBase() {}
  MyProduct1(const FactoryParams& x) : MyBase(), m_parameter(x.a1) {}
  virtual void print(ostream& os) const {
    os<<"I am Product1";
    if (!m_parameter.empty())
      os<<" with parameter '"<<m_parameter<<"'";
    os<<endl;
  }
};


class MyProduct2 : public MyBase {
  string m_parameter;
public:
  MyProduct2() : MyBase() {}
  MyProduct2(const FactoryParams& x) : MyBase(), m_parameter(x.a1) {}
  virtual void print(ostream& os) const {
    os<<"I am Product2";
    if (!m_parameter.empty())
      os<<" with paramter '"<<m_parameter<<"'";
    os<<endl;
  }
};


using regime::creator;
static creator<int,MyBase,MyProduct1>    s_p1_int_creator(1);
static creator<string,MyBase,MyProduct1> s_p1_str_creator("product1");
static creator<int,MyBase,MyProduct2>    s_p2_int_creator(2);
static creator<string,MyBase,MyProduct2> s_p2_str_creator("product2");


int main() {

  cout<<"Hello world"<<endl;
  MyBase* b1 = IntFactory::create(1);
  if (b1 == 0)
    cout<<"product with key '1' cannot be created"<<endl;
  else
    cout<<*b1<<endl;

  cout<<"IntFactory keys: ";
  const IntFactory::keys& ikeys = IntFactory::query_keys();
  copy(ikeys.begin(), ikeys.end(), ostream_iterator<int>(cout, " "));
  cout<<endl;

  cout<<"StringFactory keys: ";
  const StringFactory::keys& skeys = StringFactory::query_keys();
  copy(skeys.begin(), skeys.end(), ostream_iterator<string>(cout, " "));
  cout<<endl;

  cout<<"StringFactory libraries:"<<endl;
  const StringFactory::libraries slibs = StringFactory::query_libraries();
  copy(slibs.begin(), slibs.end(), 
    ostream_iterator<StringFactory::libraries::value_type>(cout));

  return 0;
}


